unit FichePrincipale;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Math, Menus, StrUtils, Clipbrd, Buttons;

type
  M=array [1..2,1..12] of string;
  TForm1 = class(TForm)
    sign: TComboBox;            // Nombre significatif 1
    sign2: TComboBox;           // Nombre significatif 2
    sign3: TComboBox;           // Nombre significatif 3
    mult: TComboBox;            // Nombre multiplicateur
    tole: TComboBox;            // Couleurs des tolrances
    valeur: TEdit;              // Champ valeur de la rsistance
    unite: TComboBox;           // Unit de la valeur
    nbtole: TComboBox;          // Valeurs des tolrances
    nbtemp: TComboBox;          // Valeurs des Coefficients de temprature
    temp: TComboBox;            // Couleurs des Coefficients de temprature
    EnsembleValeurs: TGroupBox;
    titre: TLabel;
    logo: TImage;
    Couleur6: TShape;
    Couleur5: TShape;
    Couleur4: TShape;
    Couleur3: TShape;
    Couleur2: TShape;
    Couleur1: TShape;
    Image1: TImage;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Popup: TPopupMenu;
    CopyVal: TMenuItem;
    NbCouleurs: TMenuItem;
    ontop: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    FondResistance: TImage;
    ButOptions: TSpeedButton;
    ButAPropos: TSpeedButton;
    ButQuit: TSpeedButton;
    Encadrement: TLabel;
    procedure ButAProposClick(Sender: TObject);
    procedure ButQuitClick(Sender: TObject);
    procedure ActualiseAvecCouleurs;
    procedure FormCreate(Sender: TObject);
    procedure coulChange(Sender: TObject);
    procedure ButOptionsClick(Sender: TObject);
    procedure ontopClick(Sender: TObject);
    procedure ActualiseAvecValeurs;
    procedure valChange(Sender: TObject);
    procedure CopyValClick(Sender: TObject);
    procedure ChangeNbCouleurs(sender : TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  tR : Byte;
  Conv : M;
  nbtotal : Extended;
  canactualise : Boolean;
  encdr0, encdr1, encdr2 : Extended;
  u, valtol : string;

implementation

uses APropos;

{$R *.dfm}
{$R WindowsXP.res}
{$R PIC.res}

procedure TForm1.ButAProposClick(Sender: TObject);
begin
Form1.Visible := False;
Form2.ShowModal;
Form1.Visible := True;
end;

procedure TForm1.ButQuitClick(Sender: TObject);
begin
Close;
end;

procedure TForm1.ActualiseAvecCouleurs;
var
a : Byte;
begin
if not canactualise then exit;
canactualise := False;
// SPECIALITES DE LA RESISTANCE A 4 BANDES
 if tR = 4 then
  begin
  nbtotal := ((sign.ItemIndex * 10) + sign2.ItemIndex) * Power(10,(mult.ItemIndex-2));
  For a := 1 to 12 do
   begin
    if mult.Items[mult.ItemIndex] = Conv[1,a] then Couleur3.Brush.Color := StringToColor(Conv[2,a]);
   end;
  end

// SPECIALITES DE LA RESISTANCE A 5 BANDES
 else if tR = 5 then
  begin
  nbtotal := ((sign.ItemIndex * 100) + (sign2.ItemIndex * 10) + sign3.ItemIndex) * Power(10,(mult.ItemIndex-2));
  For a := 1 to 12 do
   begin
    if sign3.Items[sign3.ItemIndex] = Conv[1,a] then Couleur3.Brush.Color := StringToColor(Conv[2,a]);
    if mult.Items[mult.ItemIndex] = Conv[1,a] then mult.Brush.Color := StringToColor(Conv[2,a]);
   end;
  end

// SPECIALITES DE LA RESISTANCE A 6 BANDES
 else if tR = 6 then
  begin
  nbtotal := ((sign.ItemIndex * 100) + (sign2.ItemIndex * 10) + sign3.ItemIndex) * Power(10,(mult.ItemIndex-2));
  // AFFICHAGE DU COEFFICIENT DE TEMPERATURE
  nbtemp.ItemIndex := temp.ItemIndex;
  For a := 1 to 12 do
   begin
    if sign3.Items[sign3.ItemIndex] = Conv[1,a] then Couleur3.Brush.Color := StringToColor(Conv[2,a]);
    if mult.Items[mult.ItemIndex] = Conv[1,a] then Couleur4.Brush.Color := StringToColor(Conv[2,a]);
    if temp.Items[temp.ItemIndex] = Conv[1,a] then Couleur6.Brush.Color := StringToColor(Conv[2,a]);
   end;
  end;

// COMMANDES GLOBALES VALABLES POUR TOUTES LES RESISTANCES
 // SELECTION DE L'UNITE APPROPRIEE & AFFICHAGE DE LA VALEUR DE LA RESISTANCE
 valeur.Text := FloatToStr(nbtotal);
 unite.ItemIndex := 0;
 u := 'Ohm';
 If Int(nbtotal/1000) > 0 Then
  begin
   nbtotal := (nbtotal/1000);
   valeur.Text := FloatToStr(nbtotal);
   unite.ItemIndex := 1;
   u := 'KiloOhm';
  end;
 If Int(nbtotal/1000) > 0 Then
  begin
   nbtotal := (nbtotal/1000);
   valeur.Text := FloatToStr(nbtotal);
   unite.ItemIndex := 2;
   u := 'MegaOhm';
  end;
 // AFFICHAGE DES COULEURS
 For a := 1 to 12 do
  begin
   if sign.Items[sign.ItemIndex] = Conv[1,a] then Couleur1.Brush.Color := StringToColor(Conv[2,a]);
   if sign2.Items[sign2.ItemIndex] = Conv[1,a] then Couleur2.Brush.Color := StringToColor(Conv[2,a]);
   if tole.Items[tole.ItemIndex] = Conv[1,a] then Couleur5.Brush.Color := StringToColor(Conv[2,a]);
  end;
 // AFFICHAGE DE LA TOLERANCE
 nbtole.ItemIndex := tole.ItemIndex;
 encdr0 := nbtotal;
 //Calcul des bornes d'encadrement de la tolrance
 valtol := nbtole.Items[nbtole.ItemIndex];
 encdr1 := (encdr0 * (1 - (StrToFloat(LeftStr(valtol,Length(valtol)-2)) / 100)));
 encdr2 := (encdr0 * (1 + (StrToFloat(LeftStr(valtol,Length(valtol)-2)) / 100)));
 Encadrement.Caption := 'Rsistance comprise entre '#13+FloatToStr(encdr1)+' '+u+' et '+FloatToStr(encdr2)+' '+u;
 canactualise := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
a : Byte;
begin
a := 0;
// CORRESPONDANCE DES COULEURS
inc(a);conv[1,a] := 'noir';conv[2,a] := 'clBlack';
inc(a);conv[1,a] := 'marron';conv[2,a] := 'clMaroon';
inc(a);conv[1,a] := 'rouge';conv[2,a] := 'clred';
inc(a);conv[1,a] := 'orange';conv[2,a] := '$000080FF';
inc(a);conv[1,a] := 'jaune';conv[2,a] := 'clYellow';
inc(a);conv[1,a] := 'vert';conv[2,a] := 'clGreen';
inc(a);conv[1,a] := 'bleu';conv[2,a] := 'clBlue';
inc(a);conv[1,a] := 'violet';conv[2,a] := 'clFuchsia';
inc(a);conv[1,a] := 'gris';conv[2,a] := 'clGray';
inc(a);conv[1,a] := 'blanc';conv[2,a] := 'clWhite';
inc(a);conv[1,a] := 'or';conv[2,a] := '$0089D1CF';
inc(a);conv[1,a] := 'argent';conv[2,a] := 'clSilver';
tR := 4;
canactualise := true;
ChangeNbCouleurs(N4);
end;

procedure TForm1.coulChange(Sender: TObject);
begin
 ActualiseAvecCouleurs;
end;

procedure TForm1.ButOptionsClick(Sender: TObject);
begin
 Popup.Popup(Form1.Left+ButOptions.Left+37,Form1.Top+ButOptions.Top+35);
end;

procedure TForm1.ontopClick(Sender: TObject);
begin
if OnTop.Checked then Form1.FormStyle := fsStayOnTop
else Form1.FormStyle := fsNormal;
end;

//CHANGEMENT DU NOMBRE DE BANDES DE COULEUR
procedure TForm1.ChangeNbCouleurs(sender : TObject);
begin
// 4 BANDES
if sender = N4 then
 begin
  tR := 4;
  sign3.Visible := False;
  temp.Visible := False;
  Couleur4.Visible := False;
  Couleur6.Visible := False;
  Label9.Visible := False;
  nbtemp.Visible := False;
  mult.Top := 46;
  mult.Left := 94;
  nbtole.Width := 148;
 end
 // 5 BANDES
 else if sender = N5 then
 begin
  tR := 5;
  sign3.Visible := True;
  temp.Visible := False;
  Couleur4.Visible := True;
  Couleur6.Visible := False;
  Label9.Visible := False;
  nbtemp.Visible := False;
  mult.Top := 161;
  mult.Left := 94;
  sign3.Top := 46;
  sign3.Left := 94;
  nbtole.Width := 148;
 end
// 6 BANDES
else if sender = N6 then
 begin
  tR := 6;
  sign3.Visible := True;
  temp.Visible := True;
  Couleur4.Visible := True;
  Couleur6.Visible := True;
  Label9.Visible := True;
  nbtemp.Visible := True;
  mult.Top := 161;
  mult.Left := 94;
  sign3.Top := 46;
  sign3.Left := 94;
  nbtole.Width := 65;
 end;
Image1.Picture.Bitmap.LoadFromResourceName (hInstance,'ResistPIC'+IntToStr(tR));
ActualiseAvecValeurs;
end;

procedure TForm1.ActualiseAvecValeurs;
var
 a, b, prov, nb11, nb22, nb33 : Byte;
 val, mul : Extended;
 nb1, nb2, nb3, test : string;
begin
if not canactualise then exit;
canactualise := False;
// VERIFICATION DE LA VALIDITE DE LA VALEUR
test := valeur.Text;
If Length(test)=0 then
 begin
  canactualise := True;
  Valeur.Text := IntToStr(1);
  unite.ItemIndex := 0;
  ActualiseAvecValeurs;
  exit;
 end;
For b := 0 to Length(test) do if test[b] = '.' then test[b] := ',';
 try
  val := StrToFloat(test);
 except
  Form1.Enabled := False;
  MessageBoxA(0,Pchar('Entrez une valeur numrique dans le champ ''valeur'' !'),Pchar('Erreur'),0 + MB_ICONSTOP + 0);
  Form1.Enabled := True;
  canactualise := True;
  Valeur.Text := IntToStr(1);
  unite.ItemIndex := 0;
  ActualiseAvecValeurs;
  exit;
  end;

 // CALCUL DE LA VALEUR EN FONCTION DE L'UNITE
 if unite.ItemIndex = 1 then
  begin
   val := val * 1000;
  end;
 if unite.ItemIndex = 2 then
  begin
   val := val * 1000000;
  end;

 // TEST DES VALEURS LIMITES DE RESISTANCES
 if (tR = 4) and (val>99000000) then
  begin
  Form1.Enabled := False;
  MessageBoxA(0,Pchar('ATTENTION :'+#13+'La valeur d''une rsistance de 4 bandes ne'+#13+'peut pas dpasser 99 MegaOhm !'),Pchar('Dpassement de valeur limite'),0 + MB_ICONSTOP + 0);
  Form1.Enabled := True;
  canactualise := True;
  valeur.Text := IntToStr(99);
  unite.ItemIndex := 2;
  ActualiseAvecValeurs;
  exit;
  end;

 if (tR <> 4) and (val>999000000) then
  begin
  Form1.Enabled := False;
  MessageBoxA(0,Pchar('ATTENTION :'+#13+'La valeur d''une rsistance de '+IntToStr(tR)+' bandes ne'+#13+'peut pas dpasser 999 MegaOhm !'),Pchar('Dpassement de valeur limite'),0 + MB_ICONSTOP + 0);
  Form1.Enabled := True;
  canactualise := True;
  valeur.Text := IntToStr(999);
  unite.ItemIndex := 2;
  ActualiseAvecValeurs;
  exit;
  end;

 if (val < 0.1) then
  begin
  Form1.Enabled := False;
  MessageBoxA(0,Pchar('ATTENTION :'+#13+'La valeur de la rsistance ne doit pas tre infrieure  0,1 Ohm !'),Pchar('Dpassement de valeur limite'),0 + MB_ICONSTOP + 0);
  Form1.Enabled := True;
  canactualise := True;
  valeur.Text := FloatToStr(0.1);
  unite.ItemIndex := 0;
  ActualiseAvecValeurs;
  exit;
  end;

 // ON RETROUVE LES DIFFERENTS NOMBRES SIGNIFICATIFS ET LE NOMBRE MULTIPLICATEUR... 
 mul := 0;
 While LeftStr(FloatToStr(val),1) = '0' do
  begin
   val := val * 10;
   mul := mul - 1;
  end;
 val := val * 100;
 mul := mul - 2;
 if (mul = -3) then
  begin
  val := val / 10;
  mul := mul + 1;
  end
 else
  begin
   if tR = 4 then
    begin
     While Length(FloatToStr(Int(val))) <> 2 do
      begin
       val := val / 10;
       mul := mul + 1;
      end;
    end
   else if tR >= 5 then
    begin
     While Length(FloatToStr(Int(val))) <> 3 do
      begin
       val := val / 10;
       mul := mul + 1;
      end;
    end;
  end;
  prov := 0;
 if (tR = 4) and (val < 10) then
  begin
   nb1 := '0';
   prov := 1;
  end
 else
  begin
   nb1 := LeftStr(FloatToStr(val),1);
  end;
  if (tR >= 5) and (val < 100) then
  begin
   nb1 := '0';
   prov := 1;
  end
 else
  begin
   nb1 := LeftStr(FloatToStr(val),1);
  end;

 if (tR > 4) and (val < 10) then
  begin
   nb2 := '0';
   prov := 2;
  end
 else
  begin
   nb2 := RightStr(LeftStr(FloatToStr(val),2-prov),1)
  end;
 nb11 := StrToInt(nb1);
 nb22 := StrToInt(nb2);
 nbtotal := (nb11 * 10 + nb22 ) * Power(10,mul);
 if (tR >= 5) then
  begin
   nb3 := RightStr(LeftStr(FloatToStr(val),3-prov),1);
   nb33 := StrToInt(nb3);
   nbtotal := (nb11 * 100 + nb22 * 10 + nb33 ) * Power(10,mul);
  end;

// AFFICHAGE TOLERANCE
 tole.ItemIndex := nbtole.ItemIndex;
 //Calcul de l'unit la plus approprie
 encdr0 := nbtotal;
 u := 'Ohm';
 If Int(encdr0/1000) > 0 Then
  begin
   encdr0 := (encdr0/1000);
   u := 'KiloOhm';
  end;
 If Int(encdr0/1000) > 0 Then
  begin
   encdr0 := (encdr0/1000);
   u := 'MegaOhm';
  end;
 //Calcul des bornes d'encadrement de la tolrance
 valtol := nbtole.Items[nbtole.ItemIndex];
 encdr1 := (encdr0 * (1 - (StrToFloat(LeftStr(valtol,Length(valtol)-2)) / 100)));
 encdr2 := (encdr0 * (1 + (StrToFloat(LeftStr(valtol,Length(valtol)-2)) / 100)));
 Encadrement.Caption := 'Rsistance comprise entre '#13+FloatToStr(encdr1)+' '+u+' et '+FloatToStr(encdr2)+' '+u;

// NOMBRES SIGNIFICATIFS
 sign.ItemIndex := nb11;
 sign2.ItemIndex := nb22;

// SPECIALITES DE LA RESISTANCE A 4 BANDES
 if tR = 4 then
  begin
   mult.ItemIndex := StrToInt(FloatToStr(mul)) + 2;
   For a := 1 to 12 do
    begin
     if mult.Items[mult.ItemIndex] = Conv[1,a] then Couleur3.Brush.Color := StringToColor(Conv[2,a]);
    end;
  end

// SPECIALITES DE LA RESISTANCE A 5 BANDES
 else if tR = 5 then
  begin
   sign3.ItemIndex := nb33;
   mult.ItemIndex := StrToInt(FloatToStr(mul)) + 2;
   For a := 1 to 12 do
    begin
     if sign3.Items[sign3.ItemIndex] = Conv[1,a] then Couleur3.Brush.Color := StringToColor(Conv[2,a]);
     if mult.Items[mult.ItemIndex] = Conv[1,a] then Couleur4.Brush.Color := StringToColor(Conv[2,a]);
    end;
  end

// SPECIALITES DE LA RESISTANCE A 6 BANDES
 else if tR = 6 then
  begin
   sign3.ItemIndex := nb33;
   mult.ItemIndex := StrToInt(FloatToStr(mul)) + 2;
   // COEFFICIENT DE TEMPERATURE
   temp.ItemIndex := nbtemp.ItemIndex;
   For a := 1 to 12 do
    begin
     if sign3.Items[sign3.ItemIndex] = Conv[1,a] then Couleur3.Brush.Color := StringToColor(Conv[2,a]);
     if mult.Items[mult.ItemIndex] = Conv[1,a] then Couleur4.Brush.Color := StringToColor(Conv[2,a]);
     if temp.Items[nbtemp.ItemIndex] = Conv[1,a] then Couleur6.Brush.Color := StringToColor(Conv[2,a]);
    end;
  end;

// COMMANDES GLOBALES VALABLES POUR TOUTES LES RESISTANCES
 // AFFICHAGE DES COULEURS
 For a := 1 to 12 do
  begin
   if sign.Items[sign.ItemIndex] = Conv[1,a] then Couleur1.Brush.Color := StringToColor(Conv[2,a]);
   if sign2.Items[sign2.ItemIndex] = Conv[1,a] then Couleur2.Brush.Color := StringToColor(Conv[2,a]);
   if tole.Items[tole.ItemIndex] = Conv[1,a] then Couleur5.Brush.Color := StringToColor(Conv[2,a]);
  end;
canactualise := True;
end;

procedure TForm1.valChange(Sender: TObject);
begin
ActualiseAvecValeurs;
end;

// COPIE LES VALEURS DANS LE PRESSE-PAPIERS
procedure TForm1.CopyValClick(Sender: TObject);
var
u2 : string;
begin
// On est oblig de transposer car le symbolle Omga ne s'affiche que dans la police Symbol
if unite.ItemIndex = 0 then u2 := 'Ohm'
else if unite.ItemIndex = 1 then u2 := 'KiloOhm'
else if unite.ItemIndex = 2 then u2 := 'MegaOhm';
if tR <= 5 then ClipBoard.AsText := 'Rsistance : '+valeur.Text+' '+u2+' | Tolrance : '+nbtole.Items[nbtole.ItemIndex]+' (Rsistance comprise entre '+FloatToStr(encdr1)+' '+u+' et '+FloatToStr(encdr2)+' '+u+')'
else ClipBoard.AsText := 'Rsistance : '+valeur.Text+' '+u2+' | Tolrance : '+nbtole.Items[nbtole.ItemIndex]+' (Rsistance comprise entre '+FloatToStr(encdr1)+' '+u+' et '+FloatToStr(encdr2)+' '+u+')'+' | Coefficient de temprature : '+nbtemp.Items[nbtemp.ItemIndex];
end;

end.
